Bug 825825 - Review Request: struts - Web application framework
Summary: Review Request: struts - Web application framework
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Mikolaj Izdebski
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 826955 829804
Blocks: 826645 826647 836218
TreeView+ depends on / blocked
 
Reported: 2012-05-28 15:06 UTC by gil cattaneo
Modified: 2012-07-23 14:21 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-07-08 20:53:12 UTC
Type: ---
mizdebsk: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description gil cattaneo 2012-05-28 15:06:15 UTC
Spec URL: http://gil.fedorapeople.org/struts.spec
SRPM URL: http://gil.fedorapeople.org/struts-1.3.10-1.fc16.src.rpm
Description: Welcome to the Struts Framework! The goal of this project is to provide
an open source framework useful in building web applications with Java
Servlet and JavaServer Pages (JSP) technology. Struts encourages
application architectures based on the Model-View-Controller (MVC)
design paradigm, colloquially known as Model 2 in discussions on various
servlet and JSP related mailing lists.
Struts includes the following primary areas of functionality:
A controller servlet that dispatches requests to appropriate Action
classes provided by the application developer.
JSP custom tag libraries, and associated support in the controller
servlet, that assists developers in creating interactive form-based
applications.
Utility classes to support XML parsing, automatic population of
JavaBeans properties based on the Java reflection APIs, and
internationalization of prompts and messages.
Fedora Account System Username: gil

Comment 1 Mikolaj Izdebski 2012-05-31 09:09:13 UTC
I'm taking this review.

Comment 2 Mikolaj Izdebski 2012-05-31 09:14:12 UTC
So far it doesn't build in mock because of missing dependency on apache-commons-chain. Review postponed until apache-commons-chain is available.

Comment 3 Mikolaj Izdebski 2012-05-31 11:38:15 UTC
Added depends on commons-chain bug.

Comment 4 Mikolaj Izdebski 2012-06-23 09:16:12 UTC
Some files that are included in the source RPM are non-free, not even redistributable, for example
src/core/src/main/resources/org/apache/struts/resources/web-app_2_3.dtd

Quoting from the file:

> Copyright 2000-2001 Sun Microsystems, Inc. 901 San Antonio Road,
> Palo Alto, CA  94303, U.S.A.  All rights reserved.                                                              
> 
> This product or document is protected by copyright and distributed
> under licenses restricting its use, copying, distribution, and
> decompilation.  No part of this product or documentation may be
> reproduced in any form by any means without prior written authorization
> of Sun and its licensors, if any.

This means that files like that cannot even be included in the SRPM.
Non-free files need to be excluded from the distrubution.

Please get in touch with upstream and report this matter.

Comment 5 gil cattaneo 2012-06-23 09:51:05 UTC
Spec URL: http://gil.fedorapeople.org/struts/1/struts.spec
SRPM URL: http://gil.fedorapeople.org/struts/1/struts-1.3.10-2.fc16.src.rpm
- removed non-free resources

Comment 6 Mikolaj Izdebski 2012-06-25 18:13:28 UTC
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated


==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[x]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[!]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Requires correct, justified where necessary.
[!]: MUST Rpmlint output is silent.

rpmlint struts-javadoc-1.3.10-2.fc18.noarch.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


rpmlint struts-1.3.10-2.fc18.src.rpm

struts.src: W: spelling-error %description -l en_US servlet -> settler
struts.src: W: invalid-url Source0: struts-1.3.10-clean-src.tar.gz
1 packages and 0 specfiles checked; 0 errors, 2 warnings.


rpmlint struts-1.3.10-2.fc18.noarch.rpm

struts.noarch: W: spelling-error %description -l en_US servlet -> settler
1 packages and 0 specfiles checked; 0 errors, 1 warnings.


These warnings can be ignored.


[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
Package has no sources or they are generated by developer
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[-]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[!]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.


==== Java ====
[x]: MUST If source tarball includes bundled jar/class files these need to be
     removed prior to building
[x]: MUST Packages have proper BuildRequires/Requires on jpackage-utils
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: MUST Javadoc subpackages have Requires: jpackage-utils
[x]: MUST Javadocs are placed in %{_javadocdir}/%{name} (no -%{version}
     symlink)
[x]: SHOULD Package has BuildArch: noarch (if possible)
[x]: SHOULD Package uses upstream build method (ant/maven/etc.)


==== Maven ====
[x]: MUST Pom files have correct add_maven_depmap call
     Note: Some add_maven_depmap calls found. Please check if they are correct
[!]: MUST If package uses "-Dmaven.local.depmap" explain why it was needed in
     a comment
[x]: MUST Old add_to_maven_depmap macro is not being used
[x]: MUST Packages DOES NOT have Requires(post) and Requires(postun) on
     jpackage-utils for %update_maven_depmap macro
[x]: MUST If package contains pom.xml files install it (including depmaps)
     even when building with ant
[x]: MUST Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: MUST Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms


Issues:
[!]: SHOULD Latest version is packaged.

The latest upstream release is 2.3.4, but the packaged version is 1.3.10.
Please explain why struts 1.x was packaged instead of 2.x.

[!]: MUST If package uses "-Dmaven.local.depmap" explain why it was needed in
     a comment

Please explain in a comment why local Maven depmap is needed.

[!]: MUST License file installed when any subpackage combination is installed.

Point 4 (d) of Apache License Version 2.0 requires shipping all NOTICE
files along with all derrivate works. Struts includes several such
NOTICE files, but only one of them is being installed. Please install
all NOTICE files applicable to the package.

Comment 7 gil cattaneo 2012-06-25 21:29:29 UTC
The latest upstream release is 2.3.4, but the packaged version is 1.3.10.
Please explain why struts 1.x was packaged instead of 2.x.

springframework and velocity-tools requires the struts 1.x series.

for struts 2. there are unavailable build deps such as:
org.springframework spring-aspects 3.0.5.RELEASE (depend on aspectjtools)



Please explain in a comment why local Maven depmap is needed.

depmap forcing the use of tomcat 7.x apis

Point 4 (d) of Apache License Version 2.0 requires shipping all NOTICE
files along with all derrivate works. Struts includes several such
NOTICE files, but only one of them is being installed. Please install
all NOTICE files applicable to the package.

all NOTICE files contain the same content as the one already installed

Comment 8 Mikolaj Izdebski 2012-06-26 08:28:03 UTC
> The latest upstream release is 2.3.4, but the packaged version is 1.3.10.
> Please explain why struts 1.x was packaged instead of 2.x.
> 
> springframework and velocity-tools requires the struts 1.x series.
> 
> for struts 2. there are unavailable build deps such as:
> org.springframework spring-aspects 3.0.5.RELEASE (depend on aspectjtools)

Ok, explaination good enough.

> Please explain in a comment why local Maven depmap is needed.
> 
> depmap forcing the use of tomcat 7.x apis

In a comment in the spec file I meant.

> Point 4 (d) of Apache License Version 2.0 requires shipping all NOTICE
> files along with all derrivate works. Struts includes several such
> NOTICE files, but only one of them is being installed. Please install
> all NOTICE files applicable to the package.
> 
> all NOTICE files contain the same content as the one already installed

True.

I am approving this package.

Comment 9 gil cattaneo 2012-06-26 09:15:37 UTC
Spec URL: http://gil.fedorapeople.org/struts/1/struts.spec
SRPM URL: http://gil.fedorapeople.org/struts/1/struts-1.3.10-2.fc16.src.rpm
- added comment for depmap

Comment 10 gil cattaneo 2012-06-26 09:30:11 UTC
Package Change Request
======================
Package Name: struts
New Branches: f17
Owners: gil
InitialCC: java-sig

update to 1.3.10

Comment 11 gil cattaneo 2012-06-26 10:07:12 UTC
Spec URL: http://gil.fedorapeople.org/struts/1/struts.spec
SRPM URL: http://gil.fedorapeople.org/struts/1/struts-1.3.10-2.fc16.src.rpm
- obsoletes some sub packages: manual, webapps-tomcat5

Comment 12 Gwyn Ciesla 2012-06-26 15:01:46 UTC
Git done (by process-git-requests).

Also unretired devel, please take ownership in pkgdb.

Comment 13 Fedora Update System 2012-06-29 09:26:26 UTC
struts-1.3.10-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/struts-1.3.10-3.fc17

Comment 14 Fedora Update System 2012-06-30 22:02:23 UTC
struts-1.3.10-3.fc17 has been pushed to the Fedora 17 testing repository.

Comment 15 Fedora Update System 2012-07-08 20:53:12 UTC
struts-1.3.10-3.fc17 has been pushed to the Fedora 17 stable repository.


Note You need to log in before you can comment on or make changes to this bug.